local name, addon = ...
local parentName = addon['parentName'] or "BrokerPack"
local childName = "zz_Money"
local defaults = {
	['sortDir'] = true,
}
local options = {
}
local L = LibStub("AceLocale-3.0"):GetLocale(childName, true)
local db

local texturePath = name == "BrokerPack" and "Interface\\AddOns\\BrokerPack\\zz_Money\\in.tga" or "Interface\\AddOns\\zz_Money\\in.tga"
local texturePath2 = name == "BrokerPack" and "Interface\\AddOns\\BrokerPack\\zz_Money\\out.tga" or "Interface\\AddOns\\zz_Money\\out.tga"
 
local goldicon,silvericon,coppericon
local sessionStart,sessionIn,sessionOut = 0,0,0
local mailframes = {}
local lastframe
local mailRec,mailSum
local realm, faction, player
local checkDelay = GetTime()

local posFrame = CreateFrame("Frame")
posFrame:SetWidth(32); posFrame:SetHeight(1)
posFrame:SetPoint("TOPRIGHT",SendMailFrame,"TOPRIGHT",-10,-12)
local function MAIL_FAILED(self)
	  self:UnregisterEvent('MAIL_FAILED')
	  self:UnregisterEvent('MAIL_SEND_SUCCESS')
	  addon['Print'](L['Fail'])
	  mailRec = nil
	  mailSum = nil
end

local function MAIL_SEND_SUCCESS(self)
	self:UnregisterEvent('MAIL_FAILED')
	self:UnregisterEvent('MAIL_SEND_SUCCESS')
	if(mailRec and mailSum) then
		db[realm][mailRec]['incoming'] = (db[realm][mailRec]['incoming'] or 0) + mailSum
		addon['Print'](L['Success'](mailRec,mailSum))
		mailframes[mailRec]:Hide()
	end
	mailRec = nil
	mailSum = nil
end

local mfl = CreateFrame("Frame")
mfl:SetScript("OnEvent", function(self, event, ...)
	if(event == "MAIL_SEND_SUCCESS") then
		MAIL_SEND_SUCCESS(self, event, ...)
	elseif(event == "MAIL_FAILED") then
		MAIL_FAILED(self, event, ...)
	end
end)

local function cdbCheck(n)
  db[realm][n] = db[realm][n] or { currentGold = 0 }
end

local function OnText(message)
	addon['OnText'](childName, message)
end

local function OnText2()
	local m = 0
	if(addon['db']['global']['accountMoney']) then
	  local sum = 0
	  if(addon['db']['sv']['profileKeys']) then
		for k,v in pairs(addon['db']['sv']['profileKeys']) do
		  local n,_,m = strsplit(' ',k,3)
		  if(n) then
			if(m == realm) then
			  cdbCheck(n)
			  if( faction == db[realm][n]['faction']) then
				sum = sum + db[realm][n]['currentGold']
			  end
			end
		  end
		end
	  end
	  m = sum
	else
		m = GetMoney()
	end
	if(addon['db']['global']['shortMoney'] and m>10000)then
		m = addon['round'](m / 10000,0) * 10000
	end
	OnText(addon['buildMoneyString'](m,nil,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,},addon['db']['global']['abrevK'] and L['abrK'] or nil,addon['db']['global']['abrevM'] and L['abrM'] or nil))
end

local function GetFactionList()
	local n,m,_
	local l = {}
	if(addon['db']['sv']['profileKeys']) then
		for k,v in pairs(addon['db']['sv']['profileKeys']) do
			n,_,m = strsplit(' ',k,3)
			if(n) then
				if(m == realm) then
					if(faction == db[realm][n]['faction']) then
						l[n] = true
					end 
				end
			end
		end
	end
	return l
end

local function getDeliver(name)
	local sendSum,offset
	local lim, mon
	if(db[realm][faction]['banker'] ~= player) then
		lim = db[realm][faction]['maxLimit'] or 100
		mon = GetMoney()
		sendSum = mon - lim*10000 - 30
		offset = 0
	else
		lim = db[realm][faction]['minLimit'] or 100
		mon = db[realm][name]['currentGold']
		sendSum = lim*10000 - mon
		offset = 30
	end
	if(sendSum + offset > GetMoney()) then
		sendSum = GetMoney()
	end
	return sendSum - (db[realm][faction]['banker'] ~= player and 0 or db[realm][name]['incoming'])
end


local function Click(button,name)
	local sendSum = getDeliver(name)
	if(addon['IsTwink'](addon, name) and name~=player) then
		if(sendSum>0) then
			if(SetSendMailMoney(sendSum)) then
				mfl:RegisterEvent('MAIL_SEND_SUCCESS')
				mfl:RegisterEvent('MAIL_FAILED')
				mailRec = name
				mailSum = sendSum
				SendMail(name,L['Subject'],nil)
			end
		end
	end
end

local function Mouse(name)
	if(mailframes[name]) then
		local tip = addon['qtip']:Acquire(childName.."QTip",1)
		tip:SmartAnchorTo(mailframes[name])
		tip:Clear()
		mailframes[name]['tooltip'] = tip
		if(db[realm][faction]['banker'] ~= player) then
			tip:AddLine(format("%s %s",L['Bankier'],db[realm][faction]['banker']))
			tip:AddLine(format("%s %s",L['Goldgrenze'],db[realm][faction]['maxLimit']))
		else
			tip:AddLine(format("%s %s",L['Empfaenger'],name))
			tip:AddLine(format("%s %s",L['Goldgrenze'],db[realm][faction]['minLimit']))
		end
		local sendSum = getDeliver(name)
		tip:AddLine(format("%s %s",L['Sende'],addon['buildMoneyString'](sendSum,false,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,})))
		tip:Show()
	end
end

local function MainFrame(name)
	if(getDeliver(name)<0) then return nil end
	local mailframe  = CreateFrame("Button",nil,SendMailFrame,"ActionButtonTemplate SecureActionButtonTemplate")
	mailframe:SetWidth(32); mailframe:SetHeight(32);
	mailframe:SetPoint("TOPRIGHT",lastframe,"BOTTOMRIGHT",0,-8);
	mailframe:EnableMouse(true)
	mailframe:RegisterForClicks("AnyUp")

	mailframe:SetScript("OnClick", function(_,button,_) Click(button,name) end)
	mailframe:SetScript("OnEnter", function() Mouse(name) end)
	mailframe:SetScript("OnLeave", function(self) addon['qtip']:Release(self['tooltip']) end)
	local tex = mailframe:CreateTexture(nil,"BACKGROUND")
	tex:SetTexture("Interface\\Icons\\INV_Misc_Bag_10_Blue")
	tex:SetAllPoints(mailframe)
	mailframe['texture'] = tex

	tex:SetPoint("CENTER",0,0)
	tex:Show()
	return mailframe
end
local function buildMailFrames()
	local banker = db[realm][faction]['banker']
	if(mailframes) then
		for k,v in pairs(mailframes) do
			mailframes[k]:Hide()
			mailframes[k] = nil
		end
		mailframes = {}
	end
	if(addon['db']['global']["disableBanker"]) then return end
	posFrame:Show()
	lastframe = posFrame

	if(player == banker) then
		local fl = GetFactionList()
		if(fl) then
			for k,v in pairs(fl) do
				if(k ~= banker) then
					if(getDeliver(k) > 0 and getDeliver(k) < GetMoney() - 10000) then
						mailframes[k] = MainFrame(k)
						mailframes[k]:Show()
						lastframe = mailframes[k]
					end
				end
			end
		end
	else
		if(getDeliver(banker) > 0 and getDeliver(banker) < GetMoney() - 10000) then
			mailframes[banker] = MainFrame(banker)
			mailframes[banker]:Show()
		end
	end
end

local function getDateString()
	return format("%s%s",tostring(date("%Y")),tostring(1000 + date("%j")))
end
local function getSumToday(d)
	if(faction=='Neutral') then return 0,0 end
	local sumIn,sumOut = 0,0
	d = d or 0
	local day = getDateString() + d
	for a,b in pairs(db[realm]['activity'][faction][tostring(day)] or {}) do
		if(b < 0) then
			sumOut = sumOut + b
		else
			sumIn = sumIn + b
		end
	end
	return sumOut,sumIn
end

local function getSumWeek()
	local sumIn, sumOut = 0,0
	local sumWeekIn, sumWeekOut = 0,0
	for a=0,6 do
		sumOut, sumIn = getSumToday(a * -1)
		sumWeekIn = sumWeekIn + sumIn
		sumWeekOut = sumWeekOut + sumOut
	end
	return sumWeekOut,sumWeekIn
end

local ttlist = {}

local function OnTooltip(tip)
	local zztip = type(tip.AddHeader) == 'function' and tip:AddHeader(childName) or tip:AddLine(childName)
	if(faction == 'Neutral') then 
		tip:AddLine(L['neutral'])
		return
	end
	tip:AddDoubleLine(addon['colorize'](L['Sitzung'],'ffff00'), addon['buildMoneyString'](db[realm][player]['currentGold'] - sessionStart,true,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
	tip:AddDoubleLine("|T"..texturePath..":0|t"..L['Einnahmen'], addon['buildMoneyString'](sessionIn,false,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
	tip:AddDoubleLine("|T"..texturePath2..":0|t"..L['Ausgaben'], addon['buildMoneyString'](sessionOut,false,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
	tip:AddLine(' ')
	local sumOut,sumIn = getSumToday()
	tip:AddDoubleLine(addon['colorize'](L['Heute'],'ffff00'), addon['buildMoneyString'](sumOut+sumIn,true,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
	tip:AddDoubleLine("|T"..texturePath..":0|t"..L['Einnahmen'], addon['buildMoneyString'](sumIn,false,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
	tip:AddDoubleLine("|T"..texturePath2..":0|t"..L['Ausgaben'], addon['buildMoneyString'](sumOut,false,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
	tip:AddLine(' ')
	sumOut,sumIn = getSumToday(-1)
	tip:AddDoubleLine(addon['colorize'](L['Gestern'],'ffff00'), addon['buildMoneyString'](sumOut+sumIn,true,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
	tip:AddDoubleLine("|T"..texturePath..":0|t"..L['Einnahmen'], addon['buildMoneyString'](sumIn,false,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
	tip:AddDoubleLine("|T"..texturePath2..":0|t"..L['Ausgaben'], addon['buildMoneyString'](sumOut,false,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
	tip:AddLine(' ')
	sumOut,sumIn = getSumWeek()
	tip:AddDoubleLine(addon['colorize'](L['7-Tage'],'ffff00'), addon['buildMoneyString'](sumIn+sumOut,true,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
	tip:AddDoubleLine("|T"..texturePath..":0|t"..L['Einnahmen'], addon['buildMoneyString'](sumIn,false,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
	tip:AddDoubleLine("|T"..texturePath2..":0|t"..L['Ausgaben'], addon['buildMoneyString'](sumOut,false,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
	tip:AddLine(' ')
	local sum = 0
	wipe(ttlist)
	if(addon['db']['sv']['profileKeys']) then
		for k,v in pairs(addon['db']['sv']['profileKeys']) do
		  local n,_,m = strsplit(' ',k,3)
		  if(n) then
			if(m == realm) then
			  cdbCheck(n)
			  if( faction == db[realm][n]['faction']) then
				sum = sum + db[realm][n]['currentGold']
				ttlist[n] = db[realm][n]['currentGold']
			  end
			end
		  end
		end
	end
	for _,v in pairs(addon['sortArray'](ttlist,addon['db']['global']['sortDir'])) do
		tip:AddDoubleLine(v, addon['buildMoneyString']((db[realm][v]['currentGold']+(db[realm][v]['incoming'] or 0)) or 0,nil,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
	end
	tip:AddLine(' ')
	tip:AddDoubleLine(addon['colorize'](L['Gesamt'],'ffff00'),addon['buildMoneyString'](sum,nil,{ ['iconSize'] = addon['db']['global']['iconSize'] or 12,}),1,1,1,1,1,1)
end

local oldMoney = 0

local function OnDataUpdate()
	if(checkDelay>GetTime()) then return end
	checkDelay = GetTime() + 2
	if(faction == 'Neutral') then
		faction = UnitFactionGroup('player')
		if(faction == 'Neutral') then 
			OnText2()
			return
		end
	end
	local m = GetMoney()
	if(m == oldMoney) then return end
	local stamp = time()
	local day = getDateString()
	db[realm][player] = db[realm][player] or { ['currentGold'] = m,['faction'] = faction }
	db[realm][player]['incoming'] = 0
	db[realm]['activity'] = db[realm]['activity'] or { Horde = {}, Alliance={}}
	db[realm][faction] = db[realm][faction] or {}
	db[realm][faction]['banker'] = db[realm][faction]['banker'] or player
	db[realm][faction]['minLimit'] = db[realm][faction]['minLimit'] or 300
	db[realm][faction]['maxLimit'] = db[realm][faction]['maxLimit'] or 300
	if(db[realm][player]['currentGold'] ~= m) then
		db[realm]['activity'][faction][day] = db[realm]['activity'][faction][day] or {}
		while(db[realm]['activity'][faction][day][stamp]) do
			stamp = stamp + 1
		end
		local d = m-db[realm][player]['currentGold']
		if(d < 0) then
			sessionOut = sessionOut + d
		else
			sessionIn = sessionIn + d
		end
		db[realm]['activity'][faction][day][stamp] = d
		db[realm][player]['currentGold'] = m
	end
	OnText2()
end

local function MAIL_SHOW()
  OnDataUpdate()
  buildMailFrames()
end

local function resetSession()
	player = UnitName('player')
	realm = GetRealmName()
	sessionStart = db[realm][player]['currentGold'] or 0
	sessionIn = 0
	sessionOut = 0
	OnDataUpdate()
end

local function cleanUp()
	local ci = 7
	local day = getDateString()
	if(faction == 'Neutral') then return end 
	for k,v in pairs(db[realm]['activity'][faction]) do
		if(tonumber(k) < tonumber(day)-ci) then
			db[realm]['activity'][faction][tostring(k)] = nil
		end
	end
end

local function buildSelect()
	local sel = {}
	local n,m,_
	if(addon['db']['sv']['profileKeys']) then
		for k,v in pairs(addon['db']['sv']['profileKeys']) do
			n,_,m = strsplit(' ',k,3)
			if(addon['IsTwink'](addon,n)) then
				if(faction == db[realm][n]['faction']) then
					sel[n] = n
				end
			end
		end
	end
	return sel
end

local function getPref2(info)
  return db[realm][faction][info[#info]]
end

local function setPref2(info,value)
  db[realm][faction][info[#info]] = value
  buildMailFrames()
  OnDataUpdate()
end

local function getPref(info)
	return addon['db']['global'][info[#info]]
end

local function setPref(info,value)
	oldMoney = 0
	addon['db']['global'][info[#info]] = value
	buildMailFrames()
	OnDataUpdate()
end

local function init()
	player = UnitName('player')
	realm = GetRealmName()
	faction = UnitFactionGroup('player')
	options = addon['InitConfig'](addon, childName, true, {
		['name'] = childName,
		['type'] = "data source",
		['OnTooltipShow'] = OnTooltip,
		['icon'] ="Interface\\Icons\\INV_Misc_Bag_10_Blue",
	}, getPref, setPref)
	db = addon['db']['profile'][childName]
	db[realm] = db[realm] or {
		['activity'] = { Horde = {}, Alliance={}},
		[faction] = {},
		[player] = { currentGold = 0, ['faction'] = faction },
		['banker'] = player,
	}
	db[realm][faction] = db[realm][faction] or {}
	db[realm][player] = db[realm][player] or { currentGold = 0, ['faction'] = faction }
	db[realm][player]['faction'] = faction
	db[realm][player]['incoming'] = db[realm][player]['incoming'] or 0
	local menu = addon['AddConfigMenu'](addon, {
		['name'] = L['Bankier'],
		['order'] = 2,
		['menuGet'] = getPref2,
		['menuSet'] = setPref2,
		['disabled'] = function() return addon['db']['global']["disableBanker"] end,
	}, options)
	addon['AddConfigEntry'](addon, childName, "range","minLimit",L['Minimum Limit'],L['Desc MinL'],1,10,50000,5,false,menu)
	addon['AddConfigEntry'](addon, childName, "range","maxLimit",L['Maximum Limit'],L['Desc MaxL'],2,10,50000,5,false,menu)
	addon['AddConfigEntry'](addon, childName, "select","banker",L['Bankier'],nil,3,buildSelect,nil,nil,nil,menu)
	addon['AddConfigEntry'](addon, childName, "range","iconSize",L['iconSize'],nil,2,5,32,1,false,options['args'][childName])
	addon['AddConfigEntry'](addon, childName, "toggle","sortDir",L['sortDir'],nil,2,nil,nil,nil,nil,options['args'][childName])
	addon['AddConfigEntry'](addon, childName, "toggle","disableBanker",L['nobanker'],nil,3,nil,nil,nil,nil,options['args'][childName])
	addon['AddConfigEntry'](addon, childName, "toggle","accountMoney",L['accountMoney'],L['accountMoneyDesc'],4,nil,nil,nil,nil,options['args'][childName])
	addon['AddConfigEntry'](addon, childName, "toggle","shortMoney",L['shortMoney'],nil,5,nil,nil,nil,nil,options['args'][childName])
	addon['AddConfigEntry'](addon, childName, "toggle","abrevK",L['abrevK'],nil,6,nil,nil,nil,nil,options['args'][childName])
	addon['AddConfigEntry'](addon, childName, "toggle","abrevM",L['abrevM'],nil,6,nil,nil,nil,nil,options['args'][childName])
	addon['RegisterFunc'](nil,"OnUpdate", OnDataUpdate)
	addon['RegisterFunc']({"PLAYER_MONEY"},"OnEvent", OnDataUpdate)
	addon['RegisterFunc']({"MAIL_SHOW"},"OnEvent", MAIL_SHOW)
	resetSession()
	cleanUp()
end

addon['startup'](addon, name, childName, init, true, defaults)
